--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    19:15:01 08/21/05
-- Design Name:    
-- Module Name:    sm_test - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

-- VHDL FSM (Finite State Machine) modeling
-- (ESD book Figure 2.7)
-- by Weijun Zhang, 04/2001
--
-- FSM model consists of two concurrent processes
-- state_reg and comb_logic
-- we use case statement to describe the state 
-- transistion. All the inputs and signals are
-- put into the process sensitive list.  
-----------------------------------------------------

library ieee ;
use ieee.std_logic_1164.all;

-----------------------------------------------------

entity sm_test is
port(	
	clock:		in std_logic;
	reset:		in std_logic;
	read:			in std_logic;
	write:		in std_logic;
	busy:			out std_logic;
	done:			out std_logic;
	adressout:  out std_logic_vector(18 downto 0);
	sramlowinout:	inout std_logic_vector(7 downto 0);	
	sramhighinout:	inout std_logic_vector(7 downto 0);	
	WE:			out std_logic;
	CE:			out std_logic;
	UB:			out std_logic;
	LB:			out std_logic;			
	oe:			out std_logic;
	nibble:		in std_logic;
	cntin:		in std_logic;	
	cntclear:		out std_logic
);
end sm_test;

-----------------------------------------------------

architecture  FSM  of sm_test is

-- define the states of FSM model

	type state_type is (IDLE, LESE, READY,SCHREIBE,COUNT);
	signal next_state, current_state: state_type;
	signal adress:  std_logic_vector(18 downto 0);
begin
   
    -- cocurrent process#1: state registers
    state_reg: process(clock, reset)
    begin
	 
	if (reset='1') then
          current_state <= IDLE;
	elsif (clock'event and clock='1') then
	  	  current_state <= next_state;
		end if;


    end process;						  

    -- cocurrent process#2: combinational logic
    comb_logic: process(current_state, read,write,nibble,cntin)
    begin
	 
	next_state <= current_state;
	-- use case statement to show the 
	-- state transistion
	busy <= '0';
	done <= '0';
	case current_state is
		 when IDLE =>	  
			CE <='1';
			busy <= '0';
			done <= '0';
			if read='0' or write='0' then
			   	next_state <= IDLE;
			end if;
			if read ='1' and write ='0' then
					next_state <= LESE;
			end if;
	  		if write ='1' and read = '0' then
					next_state <= SCHREIBE;
			end if;
		when LESE =>
		 	if read = '1' and write = '0' then
				 CE <= '0';
				 OE <='0';
				 WE <='1';
				 busy<= '1';
				if nibble = '0' then
			 	UB <= '0';
				LB <= '1';
			 elsif nibble = '1' then
			 	UB <= '1';
				LB <= '0';
			 end if;
			 next_state <= COUNT;	
			elsif read = '0' then
				next_state <= READY;
			end if;
	   when SCHREIBE =>
			if write = '1' and read = '0' then
			 	 CE <= '0';
				 OE <='0';
				 WE <='0';
				 busy<= '1';
			 if nibble = '0' then
			 	UB <= '0';
				LB <= '1';
			 elsif nibble = '1' then
			 	UB <= '1';
				LB <= '0';
			 end if;		 	
			 	
				 next_state <= COUNT;			
			elsif write = '0' then
				 next_state <= READY;
			end if;
		if write = '1' then
     next_state <= SCHREIBE;
  end if;
when READY =>
		  if read ='0' or write='0' then
			    adressout <= adress+1;
				 done <=	'1';
				 next_state <= IDLE;
			end if;
	 if read ='1' then
		 		next_state <= LESE;
		adressout <= adress;
			end if;
		  if write='1' then
				next_state <= SCHREIBE;
			end if;	
	 	when COUNT =>
		busy <=	'1';
		if read ='1' then
		 	cntclear <= '1';
								adress <= adress+1;
		
				next_state <= LESE;
			else 
			 next_state <= READY;
			 	 end if;
		  if write='1' then
				adressout <= adress+1;
				next_state <= SCHREIBE;
			else 
			 next_state <= READY;
			 end if;
		when others => next_state<=IDLE;
 end case;
end process;

end  FSM ;

-----------------------------------------------------
